addpath util
addpath data
addpath NN



%load mnist_uint8;
data1 = dlmread('codon_usage1.csv',',');
data2 = importdata('codon_usage2.csv',',');
data3 = unique(data2);


[s1,s2] = size(data1);
data_y = zeros(s1,11);

for i = 1:s1
    for j = 1:11
        if data2{i} == data3{j}
            data_y(i,j) = 1;
        end
    end
end

tr_x = zeros(1,s2);
tr_y = zeros(1,11);

te_x = zeros(1,s2);
te_y = zeros(1,11);

for i = 1:s1
    r = rand(1,1);
    if r < 0.1
        te_x = [te_x;data1(i,:)];
        te_y = [te_y;data_y(i,:)];
    else
        tr_x = [tr_x;data1(i,:)];
        tr_y = [tr_y;data_y(i,:)];
    end
    disp(i);
end

%save('mem.mat');
clear
load('mem.mat');

%train_x = double(train_x) / 255;
train_x = tr_x;
test_x = te_x;

%train_y = double(train_y);
train_y = tr_y;
test_y  = te_y;

% normalize
[train_x, mu, sigma] = zscore(train_x);
test_x = normalize(test_x, mu, sigma);
%% ex1 vanilla neural net

rand('state',0)
nn = nnsetup([67 35 35 11]);
opts.numepochs =  1;   %  Number of full sweeps through data
opts.batchsize = 1;  %  Take a mean gradient step over this many samples
[nn, L] = nntrain(nn, train_x, train_y, opts);
[er, bad] = nntest(nn, test_x, test_y);


disp(er);

disp('here');
assert(er < 0.08, 'Too big error');
